---
title: NotificationAction
slug: Web/API/NotificationAction
---
<div>{{APIRef("Web Notifications")}}{{AvailableInWorkers}}{{securecontext_header}}</div>

<p><span class="seoSummary">The <code>NotificationAction</code> interface of the <a href="/en-US/docs/Web/API/Notifications_API">Notifications API</a> is used to represent action buttons the user can click to interact with notifications.</span> These buttons' appearance and specific functionality vary across platforms but generally they provide a way to asynchronously show actions to the user in a notification.</p>

<h2 id="Properties">Properties</h2>

<h3 id="Instance_properties">Instance properties</h3>

<p>These properties are available only on instances of the <code>Notification</code> object.</p>

<dl>
 <dt>{{domxref("NotificationAction.action")}} {{readonlyinline}}</dt>
 <dd>The name of the action, which can be used to identify the clicked action similar to <a href="/en-US/docs/Web/API/Element/name">input names</a>.</dd>
 <dt>{{domxref("NotificationAction.title")}} {{readonlyinline}}</dt>
 <dd>The string describing the action that is displayed to the user.</dd>
 <dt>{{domxref("NotificationAction.icon")}} {{readonlyinline}}</dt>
 <dd>The URL of the image used to represent the notification when there is not enough space to display the notification itself.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Notifications can fire {{Event("notificationclick")}} events on the {{domxref("ServiceWorkerGlobalScope")}}.</p>

<p>Here a service worker shows a notification with a single "Archive" action, allowing users to perform this common task from the notification without having to open the website. The user can also click the main body of the notification to open their inbox instead.</p>

<pre class="brush: js">self.registration.showNotification("New mail from Alice", {
  actions: [
    {
      action: 'archive',
      title: 'Archive'
    }
  ]
});

self.addEventListener('notificationclick', function(event) {
  event.notification.close();
  if (event.action === 'archive') {
    // Archive action was clicked
    archiveEmail();
  } else {
    // Main body of notification was clicked
    clients.openWindow('/inbox');
  }
}, false);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Notifications')}}</td>
   <td>{{Spec2('Web Notifications')}}</td>
   <td>Living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Notification")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Notifications_API/Using_the_Notifications_API">Using the Notifications API</a></li>
</ul>
